/*
 *  interp.pov
 *  Various interpolation routines.
 *  Miroslav Broz (miroslav.broz@email.cz), Nov 25th 2003
 */

#macro interp(val1) interplin(val1) #end

#macro interplin(val1) val1 #end

#macro interpsin(val1) ((sin(val1*pi-pi/2)+1)/2) #end

#macro interp1(t1,t2,val1,val2)
  #if (clock < t1)
    val1
  #else
    #if (clock > t2)
      val2
    #else
      val1+interp((clock-t1)/(t2-t1))*(val2-val1)
    #end
  #end
#end

#macro interp2(t1,t2,t3,val1,val2,val3)
  interp4(t1,t2,t2,t3,val1,val2,val2,val3)
#end

#macro interp3(t1,t2,t3,t4,val1,val2,val3)
  interp4(t1,t2,t3,t4,val1,val2,val2,val3)
#end

#macro interp4(t1,t2,t3,t4,val1,val2,val3,val4)
  #if (clock < t1)
    val1
  #else
  #if (clock < t2)
    val1+interp((clock-t1)/(t2-t1))*(val2-val1)
  #else
  #if (clock < t3)
    val2+interp((clock-t2)/(t3-t2))*(val3-val2)
  #else
  #if (clock < t4)
    val3+interp((clock-t3)/(t4-t3))*(val4-val3)
  #else
    val4
  #end
  #end
  #end
  #end
#end

